package com.example.tdl.web;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.domain.vo.*;
import com.example.tdl.service.CircuitService;
import com.example.tdl.service.RouteService;
import com.example.tdl.service.redis.TokenRedisService;
import com.google.gson.Gson;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("/circuit")
public class CircuitController {

    private Logger logger = LoggerFactory.getLogger(CircuitController.class);

    CommFeedback fb=new CommFeedback();

    Gson gson=new Gson();

//    @Autowired
//    private CircuitService circuitService;
//
//    @Autowired
//    private RouteService routeService;
//
//    @Autowired
//    private TokenRedisService tokenRedisService;
//
//
//    //获取线路信息
//    @ApiOperation(value = "获取线路信息",notes = "获取线路信息，返回值说明：" +
//            "   transportationNo:运输编号," +
//            "   routeNumber:路由编号," +
//            "   routeName:路由名" +
//            "   startLongitude:起运经度," +
//            "   startLatitude:起运纬度," +
//            "   startCity:起运城市," +
//            "   startAddress:起运具体地址," +
//            "   startTime:起运时间," +
//            "   endLongitude:目的经度," +
//            "   endLatitude:目的纬度," +
//            "   endCity:目的城市," +
//            "   endAddress:目的具体地址," +
//            "   endTime:目的时间," +
//            "   transport:运输方式," +
//            "   alarmType:预警类型," +
//            "   boxNo:箱单号," +
//            "   containerNo:集装箱号," +
//            "   deliveryAddress:交付地址," +
//            "   transportationType:运输类型" +
//            "   circuitState:线路状态（0未开始，1运输中，2完成）," +
//            "   remark:备注," +
//            "   createTime:创建线路时间" +
//            "   evaluate:评分，" +
//            "   evaluateRemark:评分备注")
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/getAll",method = RequestMethod.GET)
//    public Object getAll(){
//        return circuitService.getAll();
//    }
//
//    //根据条件查询
//    @ApiOperation(value = "根据条件查询",notes = "根据条件查询:" +
//            "   transportationNo:运输编号," +
//            "   routeNumber:路由编号," +
//            "   alarmType:预警情况（正常传0，预警传1）" +
//            "   circuitState:线路状态（0未开始，1运输中，2完成）," +
//            "   startCity:起运城市," +
//            "   endCity:目的城市," +
//            "   startTimeMin:起运时间的最小值," +
//            "   startTimeMax:起运时间的最大值," +
//            "   endTimeMin:到达时间的最小值," +
//            "   endTimeMax:到达时间的最大值。" +
//            "返回值说明：" +
//            "   transportationNo:运输编号," +
//            "   routeNumber:路由编号," +
//            "   routeName:路由名" +
//            "   startLongitude:起运经度," +
//            "   startLatitude:起运纬度," +
//            "   startCity:起运城市," +
//            "   startAddress:起运具体地址," +
//            "   startTime:起运时间," +
//            "   endLongitude:目的经度," +
//            "   endLatitude:目的纬度," +
//            "   endCity:目的城市," +
//            "   endAddress:目的具体地址," +
//            "   endTime:目的时间," +
//            "   transport:运输方式," +
//            "   alarmType:预警类型," +
//            "   boxNo:箱单号," +
//            "   containerNo:集装箱号," +
//            "   deliveryAddress:交付地址," +
//            "   transportationType:运输类型" +
//            "   circuitState:线路状态（0未开始，1运输中，2完成）," +
//            "   remark:备注," +
//            "   createTime:创建线路时间," +
//            "   evaluate:评分，" +
//            "   evaluateRemark:评分备注")
//    @ApiImplicitParams({
//        @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/getByTerm",method = RequestMethod.POST)
//    public Object getByTerm(@RequestBody CircuitTermVo circuitTermVo){
//        if(circuitTermVo.getStartTimeMin()!=null&&circuitTermVo.getStartTimeMax()==null){
//            fb.setCode(0);
//            fb.setMessage("起运时间的最大值不能为空");
//            return gson.toJson(fb);
//        }
//        if(circuitTermVo.getEndTimeMin()!=null&&circuitTermVo.getEndTimeMax()==null){
//            fb.setCode(0);
//            fb.setMessage("到达时间的最大值不能为空");
//            return gson.toJson(fb);
//        }
//        return circuitService.getByTerm(circuitTermVo);
//    }
//
//    //添加线路信息
//    @ApiOperation(value = "添加线路信息",notes = "添加线路信息，如果是选择一条之前的已经建立的线路，" +
//            "则只用传routeNumber,startLongitude,startLatitude,startAddress,startTime,endLongitude,endLatitude,endAddress,endTime,boxNo,containerNo,deliveryAddress,transportationType,remark," +
//            "如果是新建线路，则除了routeNumber都要传，传值说明：" +
//            "   routeNumber:路由编号," +
//            "   startCountry:起运国," +
//            "   startProvince:起运省," +
//            "   startCity:起运市," +
//            "   endCountry:目的国," +
//            "   endProvince:目的省," +
//            "   endCity:目的市," +
//            "   transport:运输方式," +
//            "   createTime:创建时间," +
//            "   updateTime:修改时间," +
//            "   rRemark:路由备注," +
//            "   startLongitude:起运经度," +
//            "   startLatitude:起运纬度," +
//            "   startAddress:起运具体地址," +
//            "   startTime:起运时间," +
//            "   endLongitude:目的经度," +
//            "   endLatitude:目的纬度," +
//            "   endAddress:目的具体地址," +
//            "   endTime:目的时间," +
//            "   boxNo:箱单号," +
//            "   containerNo:集装箱号," +
//            "   deliveryAddress:交付地址," +
//            "   transportationType:运输类型," +
//            "   remark:备注")
//    @ApiImplicitParams({
//        @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/addCircuit",method = RequestMethod.POST)
//    public Object addCircuit(@RequestBody AddCircuitVo addCircuitVo){
//        if(StringUtils.isEmpty(addCircuitVo.getStartCountry())){
//            fb.setCode(0);
//            fb.setMessage("起运国不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getStartCity())){
//            fb.setCode(0);
//            fb.setMessage("起运市不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getEndCountry())){
//            fb.setCode(0);
//            fb.setMessage("目的国不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getEndCity())){
//            fb.setCode(0);
//            fb.setMessage("目的市不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getTransport())){
//            fb.setCode(0);
//            fb.setMessage("运输方式不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getStartLongitude())){
//            fb.setCode(0);
//            fb.setMessage("起运经度不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getStartLatitude())){
//            fb.setCode(0);
//            fb.setMessage("起运纬度不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getStartAddress())){
//            fb.setCode(0);
//            fb.setMessage("起运具体地址不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getEndLongitude())){
//            fb.setCode(0);
//            fb.setMessage("目的经度不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getEndLatitude())){
//            fb.setCode(0);
//            fb.setMessage("目的纬度不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getEndAddress())){
//            fb.setCode(0);
//            fb.setMessage("目的具体地址不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getBoxNo())){
//            fb.setCode(0);
//            fb.setMessage("箱单号不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getContainerNo())){
//            fb.setCode(0);
//            fb.setMessage("集装箱号/车牌号不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getDeliveryAddress())){
//            fb.setCode(0);
//            fb.setMessage("交付地址不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addCircuitVo.getTransportationType())){
//            fb.setCode(0);
//            fb.setMessage("运输类型不能为空");
//            return gson.toJson(fb);
//        }
//        if(!addCircuitVo.getStartLatitude().matches("^-?(([1-9])((\\.\\d{1,6})?)|([1-8]\\d)((\\.\\d{1,6})?)|90)$")){
//            fb.setCode(0);
//            fb.setMessage("纬度的范围为-90~90");
//            return gson.toJson(fb);
//        }
//        if(!addCircuitVo.getStartLongitude().matches("^-?(([1-9]\\d?)((\\.\\d{1,6})?)|(1[1-7]\\d)((\\.\\d{1,6})?)|180)$")) {
//            fb.setCode(0);
//            fb.setMessage("经度的范围为-180~180");
//            return gson.toJson(fb);
//        }
//        if(!addCircuitVo.getEndLatitude().matches("^-?(([1-9])((\\.\\d{1,6})?)|([1-8]\\d)((\\.\\d{1,6})?)|90)$")){
//            fb.setCode(0);
//            fb.setMessage("纬度的范围为-90~90");
//            return gson.toJson(fb);
//        }
//        if(!addCircuitVo.getEndLongitude().matches("^-?(([1-9]\\d?)((\\.\\d{1,6})?)|(1[1-7]\\d)((\\.\\d{1,6})?)|180)$")) {
//            fb.setCode(0);
//            fb.setMessage("经度的范围为-180~180");
//            return gson.toJson(fb);
//        }
//        if (!addCircuitVo.getTransport().equals("铁路")&&
//                !addCircuitVo.getTransport().equals("汽运")&&
//                !addCircuitVo.getTransport().equals("海运")&&
//                !addCircuitVo.getTransport().equals("空运")&&
//                !addCircuitVo.getTransport().equals("快递")){
//            fb.setCode(0);
//            fb.setMessage("请选择正确的运输方式");
//            return gson.toJson(fb);
//        }
//        if (!addCircuitVo.getDeliveryAddress().equals("港口")&&
//                !addCircuitVo.getDeliveryAddress().equals("仓库")&&
//                !addCircuitVo.getDeliveryAddress().equals("站点")){
//            fb.setCode(0);
//            fb.setMessage("请输入正确的交付地址");
//            return gson.toJson(fb);
//        }
//        if (!addCircuitVo.getTransportationType().equals("本地运输")&&
//                !addCircuitVo.getTransportationType().equals("国际运输")){
//            fb.setCode(0);
//            fb.setMessage("请输入正确的运输类型");
//            return gson.toJson(fb);
//        }
//        Date day=new Date();
//        SimpleDateFormat df = new SimpleDateFormat("yyyyMMdd");
//        Map<Object,Object> map=new HashMap<>();
//        map.put("startCountry",addCircuitVo.getStartCountry());
//        map.put("startProvince",addCircuitVo.getStartProvince());
//        map.put("startCity",addCircuitVo.getStartCity());
//        map.put("endCountry",addCircuitVo.getEndCountry());
//        map.put("endProvince",addCircuitVo.getEndProvince());
//        map.put("endCity",addCircuitVo.getEndCity());
//        map.put("transport",addCircuitVo.getTransport());
//        map.put("createTime",System.currentTimeMillis());
//        map.put("updateTime",System.currentTimeMillis());
//        map.put("rRemark",addCircuitVo.getrRemark());
//        map.put("startLongitude",addCircuitVo.getStartLongitude());
//        map.put("startLatitude",addCircuitVo.getStartLatitude());
//        map.put("startAddress",addCircuitVo.getStartAddress());
//        map.put("startTime",System.currentTimeMillis());
//        map.put("endLongitude",addCircuitVo.getEndLongitude());
//        map.put("endLatitude",addCircuitVo.getEndLatitude());
//        map.put("endAddress",addCircuitVo.getEndAddress());
//        map.put("endTime",0);
//        map.put("boxNo",addCircuitVo.getBoxNo());
//        map.put("containerNo",addCircuitVo.getContainerNo());
//        map.put("deliveryAddress",addCircuitVo.getDeliveryAddress());
//        map.put("transportationType",addCircuitVo.getTransportationType());
//        map.put("remark",addCircuitVo.getRemark());
//        String transportationNo = "";
//        if (addCircuitVo.getTransportationType().equals("国际运输")){
//            transportationNo="HUN"+df.format(day);
//        }
//        if (addCircuitVo.getTransportationType().equals("本地运输")){
//            transportationNo="CHN"+df.format(day);
//        }
//        String routeNumber="RT"+df.format(day);
//        String routeName=addCircuitVo.getStartCountry()+addCircuitVo.getStartCity()+"_"+addCircuitVo.getEndCountry()+addCircuitVo.getEndCity();
//        if (addCircuitVo.getTransport().equals("汽运")){
//            routeName=routeName+"_汽运";
//            routeNumber=routeNumber+"G";
//            transportationNo=transportationNo+"G";
//        }
//        if (addCircuitVo.getTransport().equals("铁路")){
//            routeName=routeName+"_铁路";
//            routeNumber=routeNumber+"T";
//            transportationNo=transportationNo+"T";
//        }
//        if (addCircuitVo.getTransport().equals("空运")){
//            routeName=routeName+"_空运";
//            routeNumber=routeNumber+"K";
//            transportationNo=transportationNo+"K";
//        }
//        if (addCircuitVo.getTransport().equals("快递")){
//            routeName=routeName+"_快递";
//            routeNumber=routeNumber+"D";
//            transportationNo=transportationNo+"D";
//        }
//        if (addCircuitVo.getTransport().equals("海运")){
//            routeName=routeName+"_海运";
//            routeNumber=routeNumber+"H";
//            transportationNo=transportationNo+"H";
//        }
//        routeNumber=routeNumber+((int)(Math.random()*(9999-1000+1))+1000);
//        if (routeService.getByRouteNumber(routeNumber)>0){
//            while (routeService.getByRouteNumber(routeNumber)>0){
//                routeNumber=routeNumber+((int)(Math.random()*(9999-1000+1))+1000);
//            }
//        }
//        transportationNo=transportationNo+((int)(Math.random()*(9999-1000+1))+1000);
//        if (circuitService.getByTransportationNo(transportationNo)!=null){
//            while (routeService.getByRouteNumber(transportationNo)>0){
//                transportationNo=transportationNo+((int)(Math.random()*(9999-1000+1))+1000);
//            }
//        }
//        map.put("routeName",routeName);
//        map.put("routeNumber",routeNumber);
//        map.put("transportationNo",transportationNo);
//        circuitService.addCircuit(map);
//        Map<Object,Object> msg=new HashMap<>();
//        msg.put("msg",map.get("msg"));
//        if (msg.get("msg").equals("添加线路成功")){
//            fb.setCode(1);
//            fb.setMessage("添加线路成功");
//        }else {
//            fb.setCode(0);
//            fb.setMessage(msg.get("msg").toString());
//        }
//        return gson.toJson(fb);
//    }
//
//    //修改线路结束时间
//    @ApiOperation(value = "修改线路结束时间",notes = "修改线路结束时间，传值说明：" +
//            "   transportationNo:运输编号," +
//            "   endTime:目的时间 " )
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/updateEndTime",method = RequestMethod.POST)
//    public Object updateEndTime(@RequestBody UpdateCircuitVo updateCircuitVo){
//        if (StringUtils.isEmpty(updateCircuitVo.getTransportationNo())){
//            fb.setCode(0);
//            fb.setMessage("需要修改的运输编号不能为空");
//            return gson.toJson(fb);
//        }
//        if (updateCircuitVo.getEndTime()==null){
//            fb.setCode(0);
//            fb.setMessage("线路结束时间不能为空");
//            return gson.toJson(fb);
//        }
//        if (circuitService.getByTransportationNo(updateCircuitVo.getTransportationNo()).getCircuitState()!=2){
//            fb.setCode(0);
//            fb.setMessage("线路未完成");
//            return gson.toJson(fb);
//        }
//        int a = circuitService.updateEndTime(updateCircuitVo);
//        if (a>0){
//            fb.setCode(1);
//            fb.setMessage("修改线路结束时间成功");
//        }else{
//            fb.setCode(0);
//            fb.setMessage("修改线路结束时间失败");
//        }
//        return gson.toJson(fb);
//    }
//
//    //修改线路信息
//    @ApiOperation(value = "修改线路信息",notes = "修改线路信息，传值说明：" +
//            "   transportationNo:需要修改的运输编号," +
//            "   routeNumber:修改之后的路由编号（如果没有就是空）," +
//            "   startCountry:起运国," +
//            "   startProvince:起运省," +
//            "   startCity:起运市," +
//            "   endCountry:目的国," +
//            "   endProvince:目的省," +
//            "   endCity:目的市," +
//            "   transport:运输方式," +
//            "   createTime:创建时间," +
//            "   updateTime:修改时间," +
//            "   startLongitude:起运经度," +
//            "   startLatitude:起运纬度," +
//            "   startAddress:起运具体地址," +
//            "   startTime:起运时间," +
//            "   endLongitude:目的经度," +
//            "   endLatitude:目的纬度," +
//            "   endAddress:目的具体地址," +
//            "   endTime:目的时间," +
//            "   boxNo:箱单号," +
//            "   containerNo:集装箱号," +
//            "   deliveryAddress:交付地址," +
//            "   transportationType:运输类型," +
//            "   remark:备注")
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/updateCircuit",method = RequestMethod.POST)
//    public Object updateCircuit(@RequestBody UpdateCircuitInfo updateCircuitInfo){
//        if (StringUtils.isEmpty(updateCircuitInfo.getTransportationNo())){
//            fb.setCode(0);
//            fb.setMessage("需要修改的运输编号不能为空");
//            return gson.toJson(fb);
//        }
//        if(StringUtils.isEmpty(updateCircuitInfo.getStartCountry())){
//            fb.setCode(0);
//            fb.setMessage("起运国不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getStartCity())){
//            fb.setCode(0);
//            fb.setMessage("起运市不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getEndCountry())){
//            fb.setCode(0);
//            fb.setMessage("目的国不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getEndCity())){
//            fb.setCode(0);
//            fb.setMessage("目的市不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getTransport())){
//            fb.setCode(0);
//            fb.setMessage("运输方式不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getStartLongitude())){
//            fb.setCode(0);
//            fb.setMessage("起运经度不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getStartLatitude())){
//            fb.setCode(0);
//            fb.setMessage("起运纬度不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getStartAddress())){
//            fb.setCode(0);
//            fb.setMessage("起运具体地址不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getEndLongitude())){
//            fb.setCode(0);
//            fb.setMessage("目的经度不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getEndLatitude())){
//            fb.setCode(0);
//            fb.setMessage("目的纬度不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getEndAddress())){
//            fb.setCode(0);
//            fb.setMessage("目的具体地址不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getBoxNo())){
//            fb.setCode(0);
//            fb.setMessage("箱单号不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getContainerNo())){
//            fb.setCode(0);
//            fb.setMessage("集装箱号/车牌号不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getDeliveryAddress())){
//            fb.setCode(0);
//            fb.setMessage("交付地址不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateCircuitInfo.getTransportationType())){
//            fb.setCode(0);
//            fb.setMessage("运输类型不能为空");
//            return gson.toJson(fb);
//        }
//        if(!updateCircuitInfo.getStartLatitude().matches("^-?(([1-9])((\\.\\d{1,6})?)|([1-8]\\d)((\\.\\d{1,6})?)|90)$")){
//            fb.setCode(0);
//            fb.setMessage("纬度的范围为-90~90");
//            return gson.toJson(fb);
//        }
//        if(!updateCircuitInfo.getStartLongitude().matches("^-?(([1-9]\\d?)((\\.\\d{1,6})?)|(1[1-7]\\d)((\\.\\d{1,6})?)|180)$")) {
//            fb.setCode(0);
//            fb.setMessage("经度的范围为-180~180");
//            return gson.toJson(fb);
//        }
//        if(!updateCircuitInfo.getEndLatitude().matches("^-?(([1-9])((\\.\\d{1,6})?)|([1-8]\\d)((\\.\\d{1,6})?)|90)$")){
//            fb.setCode(0);
//            fb.setMessage("纬度的范围为-90~90");
//            return gson.toJson(fb);
//        }
//        if(!updateCircuitInfo.getEndLongitude().matches("^-?(([1-9]\\d?)((\\.\\d{1,6})?)|(1[1-7]\\d)((\\.\\d{1,6})?)|180)$")) {
//            fb.setCode(0);
//            fb.setMessage("经度的范围为-180~180");
//            return gson.toJson(fb);
//        }
//        if (!updateCircuitInfo.getTransport().equals("铁路")&&
//                !updateCircuitInfo.getTransport().equals("汽运")&&
//                !updateCircuitInfo.getTransport().equals("海运")&&
//                !updateCircuitInfo.getTransport().equals("空运")&&
//                !updateCircuitInfo.getTransport().equals("快递")){
//            fb.setCode(0);
//            fb.setMessage("请选择正确的运输方式");
//            return gson.toJson(fb);
//        }
//        if (!updateCircuitInfo.getDeliveryAddress().equals("港口")&&
//                !updateCircuitInfo.getDeliveryAddress().equals("仓库")&&
//                !updateCircuitInfo.getDeliveryAddress().equals("站点")){
//            fb.setCode(0);
//            fb.setMessage("请输入正确的交付地址");
//            return gson.toJson(fb);
//        }
//        if (!updateCircuitInfo.getTransportationType().equals("本地运输")&&
//                !updateCircuitInfo.getTransportationType().equals("国际运输")){
//            fb.setCode(0);
//            fb.setMessage("请输入正确的运输类型");
//            return gson.toJson(fb);
//        }
//        if(circuitService.getByTransportationNo(updateCircuitInfo.getTransportationNo()).getCircuitState()!=0){
//            fb.setCode(0);
//            fb.setMessage("线路只能在未开始运输时才能修改");
//            return gson.toJson(fb);
//        }
//        String routeNumber="";
//        Date day=new Date();
//        SimpleDateFormat df = new SimpleDateFormat("yyyyMMdd");
//        Map<Object,Object> map=new HashMap<>();
//        map.put("routeNumber",updateCircuitInfo.getRouteNumber());
//        map.put("startCountry",updateCircuitInfo.getStartCountry());
//        map.put("startProvince",updateCircuitInfo.getStartProvince());
//        map.put("startCity",updateCircuitInfo.getStartCity());
//        map.put("endCountry",updateCircuitInfo.getEndCountry());
//        map.put("endProvince",updateCircuitInfo.getEndProvince());
//        map.put("endCity",updateCircuitInfo.getEndCity());
//        map.put("transport",updateCircuitInfo.getTransport());
//        map.put("createTime",System.currentTimeMillis());
//        map.put("updateTime",System.currentTimeMillis());
//        map.put("transportationNo",updateCircuitInfo.getTransportationNo());
//        map.put("startLongitude",updateCircuitInfo.getStartLongitude());
//        map.put("startLatitude",updateCircuitInfo.getStartLatitude());
//        map.put("startAddress",updateCircuitInfo.getStartAddress());
//        map.put("startTime",System.currentTimeMillis());
//        map.put("endLongitude",updateCircuitInfo.getEndLongitude());
//        map.put("endLatitude",updateCircuitInfo.getEndLatitude());
//        map.put("endAddress",updateCircuitInfo.getEndAddress());
//        map.put("endTime",0);
//        map.put("boxNo",updateCircuitInfo.getBoxNo());
//        map.put("containerNo",updateCircuitInfo.getContainerNo());
//        map.put("deliveryAddress",updateCircuitInfo.getDeliveryAddress());
//        map.put("transportationType",updateCircuitInfo.getTransportationType());
//        map.put("remark",updateCircuitInfo.getRemark());
//        if (StringUtils.isEmpty(updateCircuitInfo.getRouteNumber())){
//            routeNumber="RT"+df.format(day);
//            String routeName=updateCircuitInfo.getStartCountry()+updateCircuitInfo.getStartCity()+"_"+updateCircuitInfo.getEndCountry()+updateCircuitInfo.getEndCity();
//            if (updateCircuitInfo.getTransport().equals("汽运")){
//                routeName=routeName+"_汽运";
//                routeNumber=routeNumber+"G";
//            }
//            if (updateCircuitInfo.getTransport().equals("铁路")){
//                routeName=routeName+"_铁路";
//                routeNumber=routeNumber+"T";
//            }
//            if (updateCircuitInfo.getTransport().equals("空运")){
//                routeName=routeName+"_空运";
//                routeNumber=routeNumber+"K";
//            }
//            if (updateCircuitInfo.getTransport().equals("快递")){
//                routeName=routeName+"_快递";
//                routeNumber=routeNumber+"D";
//            }
//            if (updateCircuitInfo.getTransport().equals("海运")){
//                routeName=routeName+"_海运";
//                routeNumber=routeNumber+"H";
//            }
//            routeNumber=routeNumber+((int)(Math.random()*(9999-1000+1))+1000);
//            if (routeService.getByRouteNumber(routeNumber)>0){
//                while (routeService.getByRouteNumber(routeNumber)>0){
//                    routeNumber=routeNumber+((int)(Math.random()*(9999-1000+1))+1000);
//                }
//            }
//            map.put("routeName",routeName);
//            map.put("routeNumber",routeNumber);
//        }
//        circuitService.updateCircuit(map);
//        Map<Object,Object> msg=new HashMap<>();
//        msg.put("msg",map.get("msg"));
//        if (msg.get("msg").equals("修改线路成功")){
//            fb.setCode(1);
//            fb.setMessage("修改线路成功");
//        }else{
//            fb.setCode(0);
//            fb.setMessage(msg.get("msg").toString());
//        }
//        return gson.toJson(fb);
//    }
//
//    //删除线路
//    @ApiOperation(value = "删除线路",notes = "删除线路，传值说明：" +
//            "   transportationNo:运输编号" )
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/delCircuit",method = RequestMethod.POST)
//    public Object delCircuit(@RequestBody String transportationNo){
//        JSONObject jsonObject= JSON.parseObject(transportationNo);
//        transportationNo=(String)jsonObject.get("transportationNo");
//        if (StringUtils.isEmpty(transportationNo)){
//            fb.setCode(0);
//            fb.setMessage("需要删除的运输编号不能为空");
//            return gson.toJson(fb);
//        }
//        if (circuitService.getByTransportationNo(transportationNo).getCircuitState()==1){
//            fb.setCode(0);
//            fb.setMessage("线路运输中不能删除");
//            return gson.toJson(fb);
//        }
//        int a = circuitService.delCircuit(transportationNo);
//        if (a>0){
//            fb.setCode(1);
//            fb.setMessage("删除线路成功");
//        }else{
//            fb.setCode(0);
//            fb.setMessage("删除线路失败");
//        }
//        return gson.toJson(fb);
//    }
//
//    //根据车牌号查线路
//    @ApiOperation(value = "获取线路信息",notes = "获取线路信息，返回值说明：" +
//            "   transportationNo:运输编号," +
//            "   routeNumber:路由编号," +
//            "   routeName:路由名" +
//            "   startLongitude:起运经度," +
//            "   startLatitude:起运纬度," +
//            "   startCity:起运城市," +
//            "   startAddress:起运具体地址," +
//            "   startTime:起运时间," +
//            "   endLongitude:目的经度," +
//            "   endLatitude:目的纬度," +
//            "   endCity:目的城市," +
//            "   endAddress:目的具体地址," +
//            "   endTime:目的时间," +
//            "   transport:运输方式," +
//            "   alarmType:预警类型," +
//            "   boxNo:箱单号," +
//            "   containerNo:集装箱号," +
//            "   deliveryAddress:交付地址," +
//            "   transportationType:运输类型" +
//            "   circuitState:线路状态（0未开始，1运输中，2完成）," +
//            "   remark:备注," +
//            "   createTime:创建线路时间" +
//            "   evaluate:评分，" +
//            "   evaluateRemark:评分备注")
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/getByContainerNo",method = RequestMethod.POST)
//    public Object getByContainerNo(@RequestBody String containerNo){
//        JSONObject jsonObject=JSON.parseObject(containerNo);
//        containerNo=(String)jsonObject.get("containerNo");
//        return circuitService.getByContainerNo(containerNo);
//    }
//
//    //评价
//    @ApiOperation(value = "评价",notes = "评价线路传值说明：" +
//            "   transportationNo:运输编号," +
//            "   evaluate:评分，" +
//            "   evaluateRemark:评分备注")
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/updateEvaluate",method = RequestMethod.POST)
//    public Object updateEvaluate(@RequestBody UpdateEvaluateVo updateEvaluateVo){
//        if (updateEvaluateVo.getEvaluate()==null){
//            fb.setCode(0);
//            fb.setMessage("评价的等级不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(updateEvaluateVo.getTransportationNo())){
//            fb.setCode(0);
//            fb.setMessage("需要评价的线路编号不能为空");
//            return gson.toJson(fb);
//        }
//        if (circuitService.getByTransportationNo(updateEvaluateVo.getTransportationNo()).getCircuitState()!=2){
//            fb.setCode(0);
//            fb.setMessage("线路完成运输才能评价");
//            return gson.toJson(fb);
//        }
//        if (circuitService.getByTransportationNo(updateEvaluateVo.getTransportationNo()).getEvaluate()!=null){
//            fb.setCode(0);
//            fb.setMessage("该线路已经被评价");
//            return gson.toJson(fb);
//        }
//        int a = circuitService.updateEvaluate(updateEvaluateVo);
//        if (a>0){
//            fb.setCode(1);
//            fb.setMessage("评价成功");
//        }else{
//            fb.setCode(0);
//            fb.setMessage("评价失败");
//        }
//        return gson.toJson(fb);
//    }
//
//    //根据运输状态查询线路信息
//    @ApiOperation(value = "根据运输状态查询线路信息",notes = "根据运输状态查询线路信息，传值说明：{\"circuitState\":2}  ,circuitState:线路状态（0未开始，1运输中，2完成），返回值说明：" +
//            "   transportationNo:运输编号," +
//            "   routeNumber:路由编号," +
//            "   routeName:路由名" +
//            "   startLongitude:起运经度," +
//            "   startLatitude:起运纬度," +
//            "   startCity:起运城市," +
//            "   startAddress:起运具体地址," +
//            "   startTime:起运时间," +
//            "   endLongitude:目的经度," +
//            "   endLatitude:目的纬度," +
//            "   endCity:目的城市," +
//            "   endAddress:目的具体地址," +
//            "   endTime:目的时间," +
//            "   transport:运输方式," +
//            "   alarmType:预警类型," +
//            "   boxNo:箱单号," +
//            "   containerNo:集装箱号," +
//            "   deliveryAddress:交付地址," +
//            "   transportationType:运输类型" +
//            "   circuitState:线路状态（0未开始，1运输中，2完成）," +
//            "   remark:备注," +
//            "   createTime:创建线路时间" +
//            "   evaluate:评分，" +
//            "   evaluateRemark:评分备注")
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/getByCircuitState",method = RequestMethod.POST)
//    public Object getByCircuitState(@RequestBody Map map){
//        if (!map.containsKey("circuitState")){
//            fb.setCode(0);
//            fb.setMessage("需要查询的线路状态不能为空");
//            return gson.toJson(fb);
//        }
//        return circuitService.getByCircuitState(Integer.valueOf(map.get("circuitState").toString()));
//    }

}
