package com.example.tdl.web;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.domain.vo.AddRouteVo;
import com.example.tdl.domain.vo.RouteTermVo;
import com.example.tdl.domain.vo.UpdateRouteVo;
import com.example.tdl.entity.Route;
import com.example.tdl.service.RouteService;

import com.example.tdl.service.redis.TokenRedisService;
import com.google.gson.Gson;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("/route")
public class RouteController {

    private Logger logger = LoggerFactory.getLogger(RouteController.class);

    CommFeedback fb=new CommFeedback();

    Gson gson=new Gson();

//    @Autowired
//    private RouteService routeService=new RouteService();
//
//    @Autowired
//    private TokenRedisService tokenRedisService;
//
//
//    //查询所有路由信息
//    @ApiOperation(value = "查询所有路由信息",notes = "查询所有路由信息，返回值说明：" +
//            "   routeNumber：路由编号，" +
//            "   routeName：路由名称，" +
//            "   startCountry： 启运国家，" +
//            "   startProvince：启运省，" +
//            "   startCity：启运市，" +
//            "   endCountry：目的国家，" +
//            "   endProvince：目的省，" +
//            "   endCity：目的市，" +
//            "   transport：运输方式，" +
//            "   remark：路由备注")
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/getAll",method = RequestMethod.GET)
//    public Object getAll(){
//        return routeService.getAll();
//    }
//
//    //根据条件查询路由信息
//    @ApiOperation(value = "根据条件查询路由信息",notes = "根据条件查询路由信息，传值说明：" +
//            "   routeNumber：路由编号，" +
//            "   routeName：路由名称，" +
//            "   startCity：启运市，" +
//            "   endCity：目的市，" +
//            "   transport：运输方式。" +
//            "--------------------" +
//            "返回值说明：" +
//            "   routeNumber：路由编号，" +
//            "   routeName：路由名称，" +
//            "   startCountry： 启运国家，" +
//            "   startProvince：启运省，" +
//            "   startCity：启运市，" +
//            "   endCountry：目的国家，" +
//            "   endProvince：目的省，" +
//            "   endCity：目的市，" +
//            "   transport：运输方式，" +
//            "   remark：路由备注")
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/getRouteByTerm",method = RequestMethod.POST)
//    public Object getRouteByTerm(@RequestBody RouteTermVo routeTermVo){
//        return routeService.getRouteByTerm(routeTermVo);
//    }
//
//    @ApiOperation(value = "添加路由信息",notes = "添加路由信息，都要传，说明：" +
//            "   startCountry： 启运国家，" +
//            "   startProvince：启运省，" +
//            "   startCity：启运市，" +
//            "   endCountry：目的国家，" +
//            "   endProvince：目的省，" +
//            "   endCity：目的市，" +
//            "   transport：运输方式，" +
//            "   remark：路由备注")
//    @ApiImplicitParams({
//        @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    @RequestMapping(value="/addRoute",method = RequestMethod.POST)
//    public Object addRoute(@RequestBody AddRouteVo addRouteVo){
//        if (StringUtils.isEmpty(addRouteVo.getStartCountry())){
//            fb.setCode(0);
//            fb.setMessage("启运国不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addRouteVo.getStartCity())){
//            fb.setCode(0);
//            fb.setMessage("启运市不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addRouteVo.getEndCountry())){
//            fb.setCode(0);
//            fb.setMessage("目的国不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addRouteVo.getEndCity())){
//            fb.setCode(0);
//            fb.setMessage("目的市不能为空");
//            return gson.toJson(fb);
//        }
//        if (StringUtils.isEmpty(addRouteVo.getTransport())){
//            fb.setCode(0);
//            fb.setMessage("运输方式不能为空");
//            return gson.toJson(fb);
//        }
//        if (!addRouteVo.getTransport().equals("铁路")&&
//                !addRouteVo.getTransport().equals("汽运")&&
//                !addRouteVo.getTransport().equals("海运")&&
//                !addRouteVo.getTransport().equals("空运")&&
//                !addRouteVo.getTransport().equals("快递")){
//            fb.setCode(0);
//            fb.setMessage("请选择正确的运输方式");
//            return gson.toJson(fb);
//        }
//        String routeName=addRouteVo.getStartCountry()+addRouteVo.getStartCity()+"_"+addRouteVo.getEndCountry()+addRouteVo.getEndCity();
//        Date day=new Date();
//        SimpleDateFormat df = new SimpleDateFormat("yyyyMMdd");
//        String routeNumbers="RT"+df.format(day);
//        if (addRouteVo.getTransport().equals("汽运")){
//            routeNumbers=routeNumbers+"G";
//            routeName=routeName+"_汽运";
//        }
//        if (addRouteVo.getTransport().equals("铁路")){
//            routeNumbers=routeNumbers+"T";
//            routeName=routeName+"_铁路";
//        }
//        if (addRouteVo.getTransport().equals("空运")){
//            routeNumbers=routeNumbers+"K";
//            routeName=routeName+"_空运";
//        }
//        if (addRouteVo.getTransport().equals("快递")){
//            routeNumbers=routeNumbers+"D";
//            routeName=routeName+"_快递";
//        }
//        if (addRouteVo.getTransport().equals("海运")){
//            routeNumbers=routeNumbers+"H";
//            routeName=routeName+"_海运";
//        }
//        String routeNumber=routeNumbers+((int)(Math.random()*(9999-1000+1))+1000);
//        if (routeService.getByRouteNumber(routeNumber)>0){
//            while (routeService.getByRouteNumber(routeNumber)>0){
//                routeNumber=routeNumbers+((int)(Math.random()*(9999-1000+1))+1000);
//            }
//        }
//        if (routeService.getInfoByRouteName(routeName)!=null){
//            fb.setCode(0);
//            fb.setMessage("该路由已存在");
//            return gson.toJson(fb);
//        }
//        Map<Object,Object> map=new HashMap<>();
//        map.put("routeNumber",routeNumber);
//        map.put("routeName",routeName);
//        map.put("startCountry",addRouteVo.getStartCountry());
//        map.put("startProvince",addRouteVo.getStartProvince());
//        map.put("startCity",addRouteVo.getStartCity());
//        map.put("endCountry",addRouteVo.getEndCountry());
//        map.put("endProvince",addRouteVo.getEndProvince());
//        map.put("endCity",addRouteVo.getEndCity());
//        map.put("transport",addRouteVo.getTransport());
//        map.put("createTime",System.currentTimeMillis());
//        map.put("updateTime",System.currentTimeMillis());
//        map.put("remark",addRouteVo.getRemark());
//        routeService.addRoute(map);
//        Map<Object,Object> msg=new HashMap<>();
//        msg.put("msg",map.get("msg"));
//        if (msg.get("msg").equals("添加路由成功")){
//            fb.setCode(1);
//            fb.setMessage("添加路由成功");
//        }else{
//            fb.setCode(0);
//            fb.setMessage(msg.get("msg").toString());
//        }
//        return gson.toJson(fb);
//    }
//
//    //删除路由信息
//    @ApiOperation(value = "删除路由信息",notes = "删除路由信息，传递参数：{\"routeNumber\":\"需要删除的路由编号\"}")
//    @RequestMapping(value="/delRoute",method = RequestMethod.POST)
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    public Object delRoute(@RequestBody String routeNumber){
//        JSONObject jsonObject= JSON.parseObject(routeNumber);
//        routeNumber=(String)jsonObject.get("routeNumber");
//        if (StringUtils.isEmpty(routeNumber)){
//            fb.setCode(0);
//            fb.setMessage("需要删除的路由编号不能为空");
//            return gson.toJson(fb);
//        }
//        int a=routeService.delRoute(routeNumber);
//        if (a>0){
//            fb.setCode(1);
//            fb.setMessage("删除路由信息成功");
//        }else{
//            fb.setCode(0);
//            fb.setMessage("删除路由信息失败");
//        }
//        return gson.toJson(fb);
//    }
//
//
//
//
//
////    @ApiOperation(value = "修改路由信息",notes = "修改路由信息，都要传，路由编号是需要修改的路由编号，不能改，说明：" +
////            "   routeNumber：路由编号，" +
////            "   routeName：路由名称，" +
////            "   abbreviation：名称缩写，" +
////            "   startLongitude：启运经度，" +
////            "   startLatitude：启运纬度，" +
////            "   startCountry： 启运国家，" +
////            "   startProvince：启运省，" +
////            "   startCity：启运市，" +
////            "   startAddress：启运地址，" +
////            "   endLongitude：目的经度，" +
////            "   endLatitude：目的纬度，" +
////            "   endCountry：目的国家，" +
////            "   endProvince：目的省，" +
////            "   endCity：目的市，" +
////            "   endAddress：目的地址，" +
////            "   transport：运输方式，" +
////            "   transportRemark：运输方式备注，" +
////            "   remark：路由备注")
////    @ApiImplicitParams({
////            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
////    })
////    @RequestMapping(value="/updateRoute",method = RequestMethod.POST)
////    public Object updateRoute(@RequestBody UpdateRouteVo updateRouteVo){
////        if (StringUtils.isEmpty(updateRouteVo.getStartLatitude())){
////            fb.setCode(0);
////            fb.setMessage("启运纬度不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getStartLongitude())){
////            fb.setCode(0);
////            fb.setMessage("启运经度不能为空");
////            return gson.toJson(fb);
////        }
////        if(!updateRouteVo.getStartLatitude().matches("^-?(([1-9])((\\.\\d{1,6})?)|([1-8]\\d)((\\.\\d{1,6})?)|90)$")){
////            fb.setCode(0);
////            fb.setMessage("启运纬度的范围为-90~90");
////            return gson.toJson(fb);
////        }
////        if(!updateRouteVo.getStartLongitude().matches("^-?(([1-9]\\d?)((\\.\\d{1,6})?)|(1[1-7]\\d)((\\.\\d{1,6})?)|180)$")) {
////            fb.setCode(0);
////            fb.setMessage("启运经度的范围为-180~180");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getStartCountry())){
////            fb.setCode(0);
////            fb.setMessage("启运国不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getStartProvince())){
////            fb.setCode(0);
////            fb.setMessage("启运省不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getStartCity())){
////            fb.setCode(0);
////            fb.setMessage("启运市不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getStartAddress())){
////            fb.setCode(0);
////            fb.setMessage("启运地址不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getEndLatitude())){
////            fb.setCode(0);
////            fb.setMessage("目的纬度不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getEndLongitude())){
////            fb.setCode(0);
////            fb.setMessage("目的经度不能为空");
////            return gson.toJson(fb);
////        }
////        if(!updateRouteVo.getEndLatitude().matches("^-?(([1-9])((\\.\\d{1,6})?)|([1-8]\\d)((\\.\\d{1,6})?)|90)$")){
////            fb.setCode(0);
////            fb.setMessage("目的纬度的范围为-90~90");
////            return gson.toJson(fb);
////        }
////        if(!updateRouteVo.getEndLongitude().matches("^-?(([1-9]\\d?)((\\.\\d{1,6})?)|(1[1-7]\\d)((\\.\\d{1,6})?)|180)$")) {
////            fb.setCode(0);
////            fb.setMessage("目的经度的范围为-180~180");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getEndCountry())){
////            fb.setCode(0);
////            fb.setMessage("目的国不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getEndProvince())){
////            fb.setCode(0);
////            fb.setMessage("目的省不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getEndCity())){
////            fb.setCode(0);
////            fb.setMessage("目的市不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getEndAddress())){
////            fb.setCode(0);
////            fb.setMessage("目的地址不能为空");
////            return gson.toJson(fb);
////        }
////        if (StringUtils.isEmpty(updateRouteVo.getTransport())){
////            fb.setCode(0);
////            fb.setMessage("运输方式不能为空");
////            return gson.toJson(fb);
////        }
////        if (!updateRouteVo.getTransport().equals("铁路")&&!updateRouteVo.getTransport().equals("汽运")&&!updateRouteVo.getTransport().equals("海运")&&
////                !updateRouteVo.getTransport().equals("空运")&&!updateRouteVo.getTransport().equals("快递")){
////            fb.setCode(0);
////            fb.setMessage("请选择正确的运输方式");
////            return gson.toJson(fb);
////        }
////        String routeName=updateRouteVo.getStartCity()+"-"+updateRouteVo.getEndCity();
////        String abbreviation=routeName;
////        if (updateRouteVo.getTransport().equals("汽运")){
////            abbreviation=abbreviation+"-G";
////        }
////        if (updateRouteVo.getTransport().equals("铁路")){
////            abbreviation=abbreviation+"-T";
////        }
////        if (updateRouteVo.getTransport().equals("空运")){
////            abbreviation=abbreviation+"-K";
////        }
////        if (updateRouteVo.getTransport().equals("快递")){
////            abbreviation=abbreviation+"-D";
////        }
////        if (updateRouteVo.getTransport().equals("海运")){
////            abbreviation=abbreviation+"-H";
////        }
////        int a=routeService.updateRoute(new Route(updateRouteVo.getRouteNumber(),routeName,abbreviation,updateRouteVo.getStartLongitude(),updateRouteVo.getStartLatitude(),
////                updateRouteVo.getStartCountry(),updateRouteVo.getStartProvince(),updateRouteVo.getStartCity(),updateRouteVo.getStartAddress(),
////                updateRouteVo.getEndLongitude(),updateRouteVo.getEndLatitude(),updateRouteVo.getEndCountry(),updateRouteVo.getEndProvince(),updateRouteVo.getEndCity(),
////                updateRouteVo.getEndAddress(),updateRouteVo.getTransport(),updateRouteVo.getTransportRemark(),System.currentTimeMillis(),updateRouteVo.getRemark()));
////        if (a>0){
////            fb.setCode(1);
////            fb.setMessage("修改路由成功");
////        }else{
////            fb.setCode(0);
////            fb.setMessage("修改路由失败");
////        }
////        return gson.toJson(fb);
////
////    }



}
